#!/usr/bin/python

import sys,pywbem,StringIO
#pdb.set_trace()

length = len(sys.argv)
if  length < 4:
  print 'Usage: PciSMX.py HOST NAMESPACE outputfile'
  sys.exit(1)
else:
  host = sys.argv[1]

  namespace = sys.argv[2]

  filename = sys.argv[3]

  pcidev = ['Name','PciDeviceID', 'SubsystemID','SubsystemVendorID', 'VendorID','ClassCode', 'SubclassCode','RevisionID','BusNumber','DeviceNumber','FunctionNumber','DomainNumber','CacheLineSize']

  cli=pywbem.SFCBUDSConnection('https://%s' % host)
  FILE = open(filename,"w")
  FILE.writelines("<PCIDeviceInstance>")

  provXmloutput = StringIO.StringIO()
  devices = cli.EnumerateInstances('SMX_PCIDevice',namespace)

  for device in devices:
    print >> provXmloutput, '<device '

    pcilen = len(pcidev)
    for index in range(0,pcilen):
      try:
        s = device[pcidev[index]]
        if pcidev[index] == "Name":
          search = device[pcidev[index]].find('&')
          if search != "-1":
            s = s.replace('&','and')
        print >> provXmloutput, ' %s=\"%s\" '  % (pcidev[index], s)

      except:
        print "Unknown Error"

    cards = cli.Associators(device.path,AssocClass='SMX_RealizesPCIDevice',ResultClass = 'SMX_PCICard')

    for card in cards:
      slots = cli.Associators(card.path,AssocClass='SMX_PCICardInSlot',ResultClass = 'SMX_PCISlot')

      for slot in slots:
        print >> provXmloutput, ' slotNumber=\"%s\"' % ( slot['Number'])

    print >> provXmloutput, ' />'

  FILE.writelines(provXmloutput.getvalue())
  provXmloutput.close()

  FILE.writelines("</PCIDeviceInstance>")
  FILE.close()
