#!/usr/bin/python
import sys,pywbem,StringIO
#pdb.set_trace()

cli=pywbem.SFCBUDSConnection('https://localhost')
FILE = open('slotoutput.xml','w')
FILE.writelines("<enumInstance>\n")
slots = cli.EnumerateInstances('SMX_PCISlot','root/hpq')

for slot in slots:
  cards = cli.Associators(slot.path, ResultClass = 'SMX_PCICard')

  for card in cards:
    devices = cli.Associators(card.path, ResultClass = 'SMX_PCIDevice')

    for device in devices:
      provXmloutput = StringIO.StringIO()
      print >> provXmloutput, '<device slot=\"%s\" BusNumber=\"%s\" DeviceNumber=\"%s\" FunctionNumber=\"%s\" />' % (slot['Number'], device['BusNumber'], device['DeviceNumber'], device['FunctionNumber'])

      FILE.writelines(provXmloutput.getvalue())
      provXmloutput.close()

FILE.writelines("</enumInstance>\n")
FILE.close()

